Subject: bug#49278: 28.0.50; Lisp Mode is for Common Lisp

From: João Távora <[email-masked]>
Date: Tue, 29 Jun 2021 19:25:45 +0100

On Tue, Jun 29, 2021 at 7:16 PM Eli Zaretskii <[email-masked]> wrote:
>
> > From: João Távora <[email-masked]>
> > Date: Tue, 29 Jun 2021 19:06:19 +0100
> > Cc: [email-masked]
> >
> > -  Lisp mode is the major mode for editing programs written in
> > -general-purpose Lisp dialects, such as Common Lisp.  Its mode command
> > -is @kbd{M-x lisp-mode}.  Emacs uses Lisp mode automatically for files
> > -whose names end in @file{.l}, @file{.lsp}, or @file{.lisp}.
> > +  Lisp mode is the major mode for editing programs written in Common
> > +Lisp or its ancestor dialects.  Its mode command is @kbd{M-x
> > +lisp-mode}.  Emacs uses Lisp mode automatically for files whose names
> > +end in @file{.l}, @file{.lsp}, or @file{.lisp}.
>
> This basically doesn't change anything, and the original text does
> mention CL.  If mentioning the ancestor dialects is important, we
> could add that.

The point is to make sure that noone is misinformed to think that
lisp-mode is a suitable ancestor for, say, scheme-mode or clojure-mode or
my-2021-lisp-mode.  At the time this was written, all the "general-purpose
Lisp dialects" (minus Scheme) would be handled by Lisp mode.  But
this is just not true anymore.  It's for Common Lisp and probably still
works decently for, say, the defunct MacLisp and Franz Lisp.

So it's not true that this doesn't change anything: it removes an
ambiguity. But I'm fine with any other phrasing that also removes
this ambiguity.  Make a proposal.

> >  (define-derived-mode lisp-mode lisp-data-mode "Lisp"
> > -  "Major mode for editing Lisp code for Lisps other than GNU Emacs Lisp.
> > +  "Major mode for editing Common Lisp code.
>
> Here I'd prefer to mention CL without un-mentioning the other Lisps.
> There's no reason to deny they exist or existed.

That's true, I guess.  The point is to make sure that no one gets the
temptation to derive new Lisp-ish modes based on lisp-mode for
languages that have no relation to CL.  So what to you say to:

"Major mode for editing Common Lisp and historically related Lisps"

"Major mode for editing Common Lisp and its ancestors"

"Major mode for editing code historically related to Common Lisp"

?

João